Attribute VB_Name = "Dateisuche"
Option Explicit

Public Const INVALID_HANDLE_VALUE = -1
Public Const MAX_PATH = 260
Public Const FILE_ATTRIBUTE_DIRECTORY = &H10

Type FILETIME
        dwLowDateTime As Long
        dwHighDateTime As Long
End Type

Type WIN32_FIND_DATA
        dwFileAttributes As Long
        ftCreationTime As FILETIME
        ftLastAccessTime As FILETIME
        ftLastWriteTime As FILETIME
        nFileSizeHigh As Long
        nFileSizeLow As Long
        dwReserved0 As Long
        dwReserved1 As Long
        cFileName As String * MAX_PATH
        cAlternate As String * 14
End Type

Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long
Declare Function FileTimeToSystemTime Lib "kernel32" (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) As Long

Public StopSearch As Boolean
Private Function GetFileTime(ftTime As FILETIME) As String
Dim stTime As SYSTEMTIME, retval As Long
Dim ds As Date

retval = FileTimeToSystemTime(ftTime, stTime)
If retval Then
    ds = DateSerial(stTime.wYear, stTime.wMonth, stTime.wDay)
    
    If IsDate(ds) Then
        GetFileTime = Format$(ds, "dd.mm.yyyy")
    Else
        GetFileTime = "(unbekannt)"
    End If
End If
End Function

Public Sub SearchFile(directory As String, pattern As String, InclSubFolders As Boolean, ResultCtl As ListBox, StatusLabel As Label)
Dim hFind As Long, FileData As WIN32_FIND_DATA
Dim res As Long, Newdir As String

If Right$(directory, 1) <> "\" Then directory = directory & "\"

'Unterverzeichnisse suchen
If InclSubFolders Then
    hFind = FindFirstFile(directory & "*.*", FileData)
    StatusLabel = "Suche in " & directory
    StatusLabel.Refresh
    res = True
    Do While res <> False
        If FileData.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY Then
            '"." und ".." ausschlieen
            If Left$(FileData.cFileName, 1) <> "." Then
                Newdir = directory & Left$(FileData.cFileName, InStr(FileData.cFileName, vbNullChar) - 1)
                If Right$(Newdir, 1) <> "\" Then Newdir = Newdir & "\"
                'Rekursiver Aufruf fr Unterverzeichnisse
                Call SearchFile(Newdir, pattern, InclSubFolders, ResultCtl, StatusLabel)
            End If
        End If
        res = FindNextFile(hFind, FileData)
    Loop
    Call FindClose(hFind)
End If

'Hier kommt die eigentliche Dateisuche
hFind = FindFirstFile(directory & pattern, FileData)
If hFind = INVALID_HANDLE_VALUE Then
    Exit Sub
End If

res = True
Do While res <> False
    DoEvents
    If StopSearch Then Exit Sub
    ResultCtl.AddItem Left$(FileData.cFileName, InStr(FileData.cFileName, vbNullChar) - 1) & _
     vbTab & vbTab & directory & _
     "   (" & GetFileTime(FileData.ftCreationTime) & ")"
    res = FindNextFile(hFind, FileData)
Loop
Call FindClose(hFind)
End Sub

